Index: lemon/adaptors.h
===================================================================
--- lemon/adaptors.h	(revision 464)
+++ lemon/adaptors.h	(revision 416)
@@ -2216,36 +2042,20 @@
   /// \ingroup graph_adaptors
   ///
-  /// \brief Adaptor class for viewing a digraph as an undirected graph.
-  ///
-  /// Undirector adaptor can be used for viewing a digraph as an undirected
-  /// graph. All arcs of the underlying digraph are showed in the
-  /// adaptor as an edge (and also as a pair of arcs, of course).
-  /// This adaptor conforms to the \ref concepts::Graph "Graph" concept.
-  ///
-  /// The adapted digraph can also be modified through this adaptor
-  /// by adding or removing nodes or edges, unless the \c GR template
-  /// parameter is set to be \c const.
-  ///
-  /// \tparam GR The type of the adapted digraph.
-  /// It must conform to the \ref concepts::Digraph "Digraph" concept.
-  /// It can also be specified to be \c const.
-  ///
-  /// \note The \c Node type of this adaptor and the adapted digraph are
-  /// convertible to each other, moreover the \c Edge type of the adaptor
-  /// and the \c Arc type of the adapted digraph are also convertible to
-  /// each other.
-  /// (Thus the \c Arc type of the adaptor is convertible to the \c Arc type
-  /// of the adapted digraph.)
-  template<typename GR>
-#ifdef DOXYGEN
-  class Undirector {
-#else
-  class Undirector :
-    public GraphAdaptorExtender<UndirectorBase<GR> > {
-#endif
-  public:
-    /// The type of the adapted digraph.
-    typedef GR Digraph;
-    typedef GraphAdaptorExtender<UndirectorBase<GR> > Parent;
+  /// \brief Undirect the graph
+  ///
+  /// This adaptor makes an undirected graph from a directed
+  /// graph. All arcs of the underlying digraph will be showed in the
+  /// adaptor as an edge. The Orienter adaptor is conform to the \ref
+  /// concepts::Graph "Graph concept".
+  ///
+  /// \tparam _Digraph It must be conform to the \ref
+  /// concepts::Digraph "Digraph concept". The type can be specified
+  /// to const.
+  template<typename _Digraph>
+  class Undirector
+    : public GraphAdaptorExtender<UndirectorBase<_Digraph> > {
+  public:
+    typedef _Digraph Digraph;
+    typedef GraphAdaptorExtender<UndirectorBase<Digraph> > Parent;
   protected:
     Undirector() { }
@@ -2254,36 +2064,35 @@
     /// \brief Constructor
     ///
-    /// Creates an undirected graph from the given digraph.
-    Undirector(Digraph& digraph) {
+    /// Creates a undirected graph from the given digraph
+    Undirector(_Digraph& digraph) {
       setDigraph(digraph);
     }
 
-    /// \brief Arc map combined from two original arc maps
-    ///
-    /// This map adaptor class adapts two arc maps of the underlying
-    /// digraph to get an arc map of the undirected graph.
-    /// Its value type is inherited from the first arc map type
-    /// (\c %ForwardMap).
-    template <typename ForwardMap, typename BackwardMap>
+    /// \brief ArcMap combined from two original ArcMap
+    ///
+    /// This class adapts two original digraph ArcMap to
+    /// get an arc map on the undirected graph.
+    template <typename _ForwardMap, typename _BackwardMap>
     class CombinedArcMap {
     public:
 
-      /// The key type of the map
+      typedef _ForwardMap ForwardMap;
+      typedef _BackwardMap BackwardMap;
+
+      typedef typename MapTraits<ForwardMap>::ReferenceMapTag ReferenceMapTag;
+
+      typedef typename ForwardMap::Value Value;
       typedef typename Parent::Arc Key;
-      /// The value type of the map
-      typedef typename ForwardMap::Value Value;
-
-      typedef typename MapTraits<ForwardMap>::ReferenceMapTag ReferenceMapTag;
-
-      typedef typename MapTraits<ForwardMap>::ReturnValue ReturnValue;
-      typedef typename MapTraits<ForwardMap>::ConstReturnValue ConstReturnValue;
-      typedef typename MapTraits<ForwardMap>::ReturnValue Reference;
-      typedef typename MapTraits<ForwardMap>::ConstReturnValue ConstReference;
-
+
+      /// \brief Constructor
+      ///
       /// Constructor
       CombinedArcMap(ForwardMap& forward, BackwardMap& backward)
         : _forward(&forward), _backward(&backward) {}
 
-      /// Sets the value associated with the given key.
+
+      /// \brief Sets the value associated with a key.
+      ///
+      /// Sets the value associated with a key.
       void set(const Key& e, const Value& a) {
         if (Parent::direction(e)) {
@@ -2294,6 +2103,9 @@
       }
 
-      /// Returns the value associated with the given key.
-      ConstReturnValue operator[](const Key& e) const {
+      /// \brief Returns the value associated with a key.
+      ///
+      /// Returns the value associated with a key.
+      typename MapTraits<ForwardMap>::ConstReturnValue
+      operator[](const Key& e) const {
         if (Parent::direction(e)) {
           return (*_forward)[e];
@@ -2303,6 +2115,9 @@
       }
 
-      /// Returns a reference to the value associated with the given key.
-      ReturnValue operator[](const Key& e) {
+      /// \brief Returns the value associated with a key.
+      ///
+      /// Returns the value associated with a key.
+      typename MapTraits<ForwardMap>::ReturnValue
+      operator[](const Key& e) {
         if (Parent::direction(e)) {
           return (*_forward)[e];
@@ -2319,7 +2134,7 @@
     };
 
-    /// \brief Returns a combined arc map
-    ///
-    /// This function just returns a combined arc map.
+    /// \brief Just gives back a combined arc map
+    ///
+    /// Just gives back a combined arc map
     template <typename ForwardMap, typename BackwardMap>
     static CombinedArcMap<ForwardMap, BackwardMap>
@@ -2351,14 +2166,12 @@
   };
 
-  /// \brief Returns a read-only Undirector adaptor
-  ///
-  /// This function just returns a read-only \ref Undirector adaptor.
-  /// \ingroup graph_adaptors
-  /// \relates Undirector
-  template<typename GR>
-  Undirector<const GR> undirector(const GR& digraph) {
-    return Undirector<const GR>(digraph);
+  /// \brief Just gives back an undirected view of the given digraph
+  ///
+  /// Just gives back an undirected view of the given digraph
+  template<typename Digraph>
+  Undirector<const Digraph>
+  undirector(const Digraph& digraph) {
+    return Undirector<const Digraph>(digraph);
   }
-
 
   template <typename _Graph, typename _DirectionMap>
@@ -2379,10 +2192,10 @@
     void first(Arc& i) const { _graph->first(i); }
     void firstIn(Arc& i, const Node& n) const {
-      bool d = true;
+      bool d;
       _graph->firstInc(i, d, n);
       while (i != INVALID && d == (*_direction)[i]) _graph->nextInc(i, d);
     }
     void firstOut(Arc& i, const Node& n ) const {
-      bool d = true;
+      bool d;
       _graph->firstInc(i, d, n);
       while (i != INVALID && d != (*_direction)[i]) _graph->nextInc(i, d);
@@ -2412,13 +2225,22 @@
     int nodeNum() const { return _graph->nodeNum(); }
 
-    typedef EdgeNumTagIndicator<Graph> ArcNumTag;
+    typedef EdgeNumTagIndicator<Graph> EdgeNumTag;
     int arcNum() const { return _graph->edgeNum(); }
 
-    typedef FindEdgeTagIndicator<Graph> FindArcTag;
+    typedef FindEdgeTagIndicator<Graph> FindEdgeTag;
     Arc findArc(const Node& u, const Node& v,
-                const Arc& prev = INVALID) const {
-      Arc arc = _graph->findEdge(u, v, prev);
-      while (arc != INVALID && source(arc) != u) {
+                const Arc& prev = INVALID) {
+      Arc arc = prev;
+      bool d = arc == INVALID ? true : (*_direction)[arc];
+      if (d) {
         arc = _graph->findEdge(u, v, arc);
+        while (arc != INVALID && !(*_direction)[arc]) {
+          _graph->findEdge(u, v, arc);
+        }
+        if (arc != INVALID) return arc;
+      }
+      _graph->findEdge(v, u, arc);
+      while (arc != INVALID && (*_direction)[arc]) {
+        _graph->findEdge(u, v, arc);
       }
       return arc;
@@ -2430,6 +2252,6 @@
 
     Arc addArc(const Node& u, const Node& v) {
-      Arc arc = _graph->addEdge(u, v);
-      _direction->set(arc, _graph->u(arc) == u);
+      Arc arc = _graph->addArc(u, v);
+      _direction->set(arc, _graph->source(arc) == u);
       return arc;
     }
@@ -2522,47 +2344,26 @@
   /// \ingroup graph_adaptors
   ///
-  /// \brief Adaptor class for orienting the edges of a graph to get a digraph
-  ///
-  /// Orienter adaptor can be used for orienting the edges of a graph to
-  /// get a digraph. A \c bool edge map of the underlying graph must be
-  /// specified, which define the direction of the arcs in the adaptor.
-  /// The arcs can be easily reversed by the \c reverseArc() member function
-  /// of the adaptor.
-  /// This class conforms to the \ref concepts::Digraph "Digraph" concept.
-  ///
-  /// The adapted graph can also be modified through this adaptor
-  /// by adding or removing nodes or arcs, unless the \c GR template
-  /// parameter is set to be \c const.
-  ///
-  /// \tparam GR The type of the adapted graph.
-  /// It must conform to the \ref concepts::Graph "Graph" concept.
-  /// It can also be specified to be \c const.
-  /// \tparam DM The type of the direction map.
-  /// It must be a \c bool (or convertible) edge map of the
-  /// adapted graph. The default type is
-  /// \ref concepts::Graph::EdgeMap "GR::EdgeMap<bool>".
-  ///
-  /// \note The \c Node type of this adaptor and the adapted graph are
-  /// convertible to each other, moreover the \c Arc type of the adaptor
-  /// and the \c Edge type of the adapted graph are also convertible to
-  /// each other.
-#ifdef DOXYGEN
-  template<typename GR,
-           typename DM>
-  class Orienter {
-#else
-  template<typename GR,
-           typename DM = typename GR::template EdgeMap<bool> >
+  /// \brief Orients the edges of the graph to get a digraph
+  ///
+  /// This adaptor orients each edge in the undirected graph. The
+  /// direction of the arcs stored in an edge node map.  The arcs can
+  /// be easily reverted by the \c reverseArc() member function in the
+  /// adaptor. The Orienter adaptor is conform to the \ref
+  /// concepts::Digraph "Digraph concept".
+  ///
+  /// \tparam _Graph It must be conform to the \ref concepts::Graph
+  /// "Graph concept". The type can be specified to be const.
+  /// \tparam _DirectionMap A bool valued edge map of the the adapted
+  /// graph.
+  ///
+  /// \sa orienter
+  template<typename _Graph,
+           typename DirectionMap = typename _Graph::template EdgeMap<bool> >
   class Orienter :
-    public DigraphAdaptorExtender<OrienterBase<GR, DM> > {
-#endif
-  public:
-
-    /// The type of the adapted graph.
-    typedef GR Graph;
-    /// The type of the direction edge map.
-    typedef DM DirectionMap;
-
-    typedef DigraphAdaptorExtender<OrienterBase<GR, DM> > Parent;
+    public DigraphAdaptorExtender<OrienterBase<_Graph, DirectionMap> > {
+  public:
+    typedef _Graph Graph;
+    typedef DigraphAdaptorExtender<
+      OrienterBase<_Graph, DirectionMap> > Parent;
     typedef typename Parent::Arc Arc;
   protected:
@@ -2570,7 +2371,7 @@
   public:
 
-    /// \brief Constructor
-    ///
-    /// Constructor of the adaptor.
+    /// \brief Constructor of the adaptor
+    ///
+    /// Constructor of the adaptor
     Orienter(Graph& graph, DirectionMap& direction) {
       setGraph(graph);
@@ -2578,9 +2379,7 @@
     }
 
-    /// \brief Reverses the given arc
-    ///
-    /// This function reverses the given arc.
-    /// It is done by simply negate the assigned value of \c a
-    /// in the direction map.
+    /// \brief Reverse arc
+    ///
+    /// It reverse the given arc. It simply negate the direction in the map.
     void reverseArc(const Arc& a) {
       Parent::reverseArc(a);
@@ -2588,29 +2387,32 @@
   };
 
-  /// \brief Returns a read-only Orienter adaptor
-  ///
-  /// This function just returns a read-only \ref Orienter adaptor.
-  /// \ingroup graph_adaptors
-  /// \relates Orienter
-  template<typename GR, typename DM>
-  Orienter<const GR, DM>
-  orienter(const GR& graph, DM& direction_map) {
-    return Orienter<const GR, DM>(graph, direction_map);
+  /// \brief Just gives back a Orienter
+  ///
+  /// Just gives back a Orienter
+  template<typename Graph, typename DirectionMap>
+  Orienter<const Graph, DirectionMap>
+  orienter(const Graph& graph, DirectionMap& dm) {
+    return Orienter<const Graph, DirectionMap>(graph, dm);
   }
 
-  template<typename GR, typename DM>
-  Orienter<const GR, const DM>
-  orienter(const GR& graph, const DM& direction_map) {
-    return Orienter<const GR, const DM>(graph, direction_map);
+  template<typename Graph, typename DirectionMap>
+  Orienter<const Graph, const DirectionMap>
+  orienter(const Graph& graph, const DirectionMap& dm) {
+    return Orienter<const Graph, const DirectionMap>(graph, dm);
   }
 
   namespace _adaptor_bits {
 
-    template<typename Digraph,
-             typename CapacityMap,
-             typename FlowMap,
-             typename Tolerance>
+    template<typename _Digraph,
+             typename _CapacityMap = typename _Digraph::template ArcMap<int>,
+             typename _FlowMap = _CapacityMap,
+             typename _Tolerance = Tolerance<typename _CapacityMap::Value> >
     class ResForwardFilter {
     public:
+
+      typedef _Digraph Digraph;
+      typedef _CapacityMap CapacityMap;
+      typedef _FlowMap FlowMap;
+      typedef _Tolerance Tolerance;
 
       typedef typename Digraph::Arc Key;
@@ -2633,10 +2435,15 @@
     };
 
-    template<typename Digraph,
-             typename CapacityMap,
-             typename FlowMap,
-             typename Tolerance>
+    template<typename _Digraph,
+             typename _CapacityMap = typename _Digraph::template ArcMap<int>,
+             typename _FlowMap = _CapacityMap,
+             typename _Tolerance = Tolerance<typename _CapacityMap::Value> >
     class ResBackwardFilter {
     public:
+
+      typedef _Digraph Digraph;
+      typedef _CapacityMap CapacityMap;
+      typedef _FlowMap FlowMap;
+      typedef _Tolerance Tolerance;
 
       typedef typename Digraph::Arc Key;
@@ -2664,72 +2471,51 @@
   /// \ingroup graph_adaptors
   ///
-  /// \brief Adaptor class for composing the residual digraph for directed
+  /// \brief An adaptor for composing the residual graph for directed
   /// flow and circulation problems.
   ///
-  /// ResidualDigraph can be used for composing the \e residual digraph
-  /// for directed flow and circulation problems. Let \f$ G=(V, A) \f$
-  /// be a directed graph and let \f$ F \f$ be a number type.
-  /// Let \f$ flow, cap: A\to F \f$ be functions on the arcs.
-  /// This adaptor implements a digraph structure with node set \f$ V \f$
-  /// and arc set \f$ A_{forward}\cup A_{backward} \f$,
-  /// where \f$ A_{forward}=\{uv : uv\in A, flow(uv)<cap(uv)\} \f$ and
-  /// \f$ A_{backward}=\{vu : uv\in A, flow(uv)>0\} \f$, i.e. the so
-  /// called residual digraph.
-  /// When the union \f$ A_{forward}\cup A_{backward} \f$ is taken,
-  /// multiplicities are counted, i.e. the adaptor has exactly
-  /// \f$ |A_{forward}| + |A_{backward}|\f$ arcs (it may have parallel
-  /// arcs).
-  /// This class conforms to the \ref concepts::Digraph "Digraph" concept.
-  ///
-  /// \tparam GR The type of the adapted digraph.
-  /// It must conform to the \ref concepts::Digraph "Digraph" concept.
-  /// It is implicitly \c const.
-  /// \tparam CM The type of the capacity map.
-  /// It must be an arc map of some numerical type, which defines
-  /// the capacities in the flow problem. It is implicitly \c const.
-  /// The default type is
-  /// \ref concepts::Digraph::ArcMap "GR::ArcMap<int>".
-  /// \tparam FM The type of the flow map.
-  /// It must be an arc map of some numerical type, which defines
-  /// the flow values in the flow problem. The default type is \c CM.
-  /// \tparam TL The tolerance type for handling inexact computation.
-  /// The default tolerance type depends on the value type of the
-  /// capacity map.
-  ///
-  /// \note This adaptor is implemented using Undirector and FilterArcs
-  /// adaptors.
-  ///
-  /// \note The \c Node type of this adaptor and the adapted digraph are
-  /// convertible to each other, moreover the \c Arc type of the adaptor
-  /// is convertible to the \c Arc type of the adapted digraph.
-#ifdef DOXYGEN
-  template<typename GR, typename CM, typename FM, typename TL>
-  class ResidualDigraph
-#else
-  template<typename GR,
-           typename CM = typename GR::template ArcMap<int>,
-           typename FM = CM,
-           typename TL = Tolerance<typename CM::Value> >
-  class ResidualDigraph :
+  /// An adaptor for composing the residual graph for directed flow and
+  /// circulation problems.  Let \f$ G=(V, A) \f$ be a directed graph
+  /// and let \f$ F \f$ be a number type. Let moreover \f$ f,c:A\to F \f$,
+  /// be functions on the arc-set.
+  ///
+  /// Then Residual implements the digraph structure with
+  /// node-set \f$ V \f$ and arc-set \f$ A_{forward}\cup A_{backward} \f$,
+  /// where \f$ A_{forward}=\{uv : uv\in A, f(uv)<c(uv)\} \f$ and
+  /// \f$ A_{backward}=\{vu : uv\in A, f(uv)>0\} \f$, i.e. the so
+  /// called residual graph.  When we take the union
+  /// \f$ A_{forward}\cup A_{backward} \f$, multiplicities are counted,
+  /// i.e.  if an arc is in both \f$ A_{forward} \f$ and
+  /// \f$ A_{backward} \f$, then in the adaptor it appears in both
+  /// orientation.
+  ///
+  /// \tparam _Digraph It must be conform to the \ref concepts::Digraph
+  /// "Digraph concept". The type is implicitly const.
+  /// \tparam _CapacityMap An arc map of some numeric type, it defines
+  /// the capacities in the flow problem. The map is implicitly const.
+  /// \tparam _FlowMap An arc map of some numeric type, it defines
+  /// the capacities in the flow problem.
+  /// \tparam _Tolerance Handler for inexact computation.
+  template<typename _Digraph,
+           typename _CapacityMap = typename _Digraph::template ArcMap<int>,
+           typename _FlowMap = _CapacityMap,
+           typename _Tolerance = Tolerance<typename _CapacityMap::Value> >
+  class Residual :
     public FilterArcs<
-      Undirector<const GR>,
-      typename Undirector<const GR>::template CombinedArcMap<
-        _adaptor_bits::ResForwardFilter<const GR, CM, FM, TL>,
-        _adaptor_bits::ResBackwardFilter<const GR, CM, FM, TL> > >
-#endif
+    Undirector<const _Digraph>,
+    typename Undirector<const _Digraph>::template CombinedArcMap<
+      _adaptor_bits::ResForwardFilter<const _Digraph, _CapacityMap,
+                                      _FlowMap, _Tolerance>,
+      _adaptor_bits::ResBackwardFilter<const _Digraph, _CapacityMap,
+                                       _FlowMap, _Tolerance> > >
   {
   public:
 
-    /// The type of the underlying digraph.
-    typedef GR Digraph;
-    /// The type of the capacity map.
-    typedef CM CapacityMap;
-    /// The type of the flow map.
-    typedef FM FlowMap;
-    /// The tolerance type.
-    typedef TL Tolerance;
+    typedef _Digraph Digraph;
+    typedef _CapacityMap CapacityMap;
+    typedef _FlowMap FlowMap;
+    typedef _Tolerance Tolerance;
 
     typedef typename CapacityMap::Value Value;
-    typedef ResidualDigraph Adaptor;
+    typedef Residual Adaptor;
 
   protected:
@@ -2744,5 +2530,5 @@
 
     typedef typename Undirected::
-      template CombinedArcMap<ForwardFilter, BackwardFilter> ArcFilter;
+    template CombinedArcMap<ForwardFilter, BackwardFilter> ArcFilter;
 
     typedef FilterArcs<Undirected, ArcFilter> Parent;
@@ -2758,10 +2544,10 @@
   public:
 
-    /// \brief Constructor
-    ///
-    /// Constructor of the residual digraph adaptor. The parameters are the
-    /// digraph, the capacity map, the flow map, and a tolerance object.
-    ResidualDigraph(const Digraph& digraph, const CapacityMap& capacity,
-                    FlowMap& flow, const Tolerance& tolerance = Tolerance())
+    /// \brief Constructor of the residual digraph.
+    ///
+    /// Constructor of the residual graph. The parameters are the digraph,
+    /// the flow map, the capacity map and a tolerance object.
+    Residual(const Digraph& digraph, const CapacityMap& capacity,
+             FlowMap& flow, const Tolerance& tolerance = Tolerance())
       : Parent(), _capacity(&capacity), _flow(&flow), _graph(digraph),
         _forward_filter(capacity, flow, tolerance),
@@ -2775,7 +2561,7 @@
     typedef typename Parent::Arc Arc;
 
-    /// \brief Returns the residual capacity of the given arc.
-    ///
-    /// Returns the residual capacity of the given arc.
+    /// \brief Gives back the residual capacity of the arc.
+    ///
+    /// Gives back the residual capacity of the arc.
     Value residualCapacity(const Arc& a) const {
       if (Undirected::direction(a)) {
@@ -2786,9 +2572,9 @@
     }
 
-    /// \brief Augments on the given arc in the residual digraph.
-    ///
-    /// Augments on the given arc in the residual digraph. It increases
-    /// or decreases the flow value on the original arc according to the
-    /// direction of the residual arc.
+    /// \brief Augment on the given arc in the residual graph.
+    ///
+    /// Augment on the given arc in the residual graph. It increase
+    /// or decrease the flow on the original arc depend on the direction
+    /// of the residual arc.
     void augment(const Arc& a, const Value& v) const {
       if (Undirected::direction(a)) {
@@ -2799,32 +2585,28 @@
     }
 
-    /// \brief Returns \c true if the given residual arc is a forward arc.
-    ///
-    /// Returns \c true if the given residual arc has the same orientation
-    /// as the original arc, i.e. it is a so called forward arc.
+    /// \brief Returns the direction of the arc.
+    ///
+    /// Returns true when the arc is same oriented as the original arc.
     static bool forward(const Arc& a) {
       return Undirected::direction(a);
     }
 
-    /// \brief Returns \c true if the given residual arc is a backward arc.
-    ///
-    /// Returns \c true if the given residual arc has the opposite orientation
-    /// than the original arc, i.e. it is a so called backward arc.
+    /// \brief Returns the direction of the arc.
+    ///
+    /// Returns true when the arc is opposite oriented as the original arc.
     static bool backward(const Arc& a) {
       return !Undirected::direction(a);
     }
 
-    /// \brief Returns the forward oriented residual arc.
-    ///
-    /// Returns the forward oriented residual arc related to the given
-    /// arc of the underlying digraph.
+    /// \brief Gives back the forward oriented residual arc.
+    ///
+    /// Gives back the forward oriented residual arc.
     static Arc forward(const typename Digraph::Arc& a) {
       return Undirected::direct(a, true);
     }
 
-    /// \brief Returns the backward oriented residual arc.
-    ///
-    /// Returns the backward oriented residual arc related to the given
-    /// arc of the underlying digraph.
+    /// \brief Gives back the backward oriented residual arc.
+    ///
+    /// Gives back the backward oriented residual arc.
     static Arc backward(const typename Digraph::Arc& a) {
       return Undirected::direct(a, false);
@@ -2833,20 +2615,19 @@
     /// \brief Residual capacity map.
     ///
-    /// This map adaptor class can be used for obtaining the residual
-    /// capacities as an arc map of the residual digraph.
-    /// Its value type is inherited from the capacity map.
+    /// In generic residual graph the residual capacity can be obtained
+    /// as a map.
     class ResidualCapacity {
     protected:
       const Adaptor* _adaptor;
     public:
-      /// The key type of the map
+      /// The Key type
       typedef Arc Key;
-      /// The value type of the map
-      typedef typename CapacityMap::Value Value;
+      /// The Value type
+      typedef typename _CapacityMap::Value Value;
 
       /// Constructor
       ResidualCapacity(const Adaptor& adaptor) : _adaptor(&adaptor) {}
 
-      /// Returns the value associated with the given residual arc
+      /// \e
       Value operator[](const Arc& a) const {
         return _adaptor->residualCapacity(a);
@@ -2855,24 +2636,5 @@
     };
 
-    /// \brief Returns a residual capacity map
-    ///
-    /// This function just returns a residual capacity map.
-    ResidualCapacity residualCapacity() const {
-      return ResidualCapacity(*this);
-    }
-
   };
-
-  /// \brief Returns a (read-only) Residual adaptor
-  ///
-  /// This function just returns a (read-only) \ref Residual adaptor.
-  /// \ingroup graph_adaptors
-  /// \relates Residual
-  template<typename GR, typename CM, typename FM>
-  ResidualDigraph<GR, CM, FM>
-  residualDigraph(const GR& digraph, const CM& capacity_map, FM& flow_map) {
-    return ResidualDigraph<GR, CM, FM> (digraph, capacity_map, flow_map);
-  }
-
 
   template <typename _Digraph>
@@ -3123,24 +2885,28 @@
 
     typedef True NodeNumTag;
+
     int nodeNum() const {
       return  2 * countNodes(*_digraph);
     }
 
-    typedef True ArcNumTag;
+    typedef True EdgeNumTag;
     int arcNum() const {
       return countArcs(*_digraph) + countNodes(*_digraph);
     }
 
-    typedef True FindArcTag;
+    typedef True FindEdgeTag;
     Arc findArc(const Node& u, const Node& v,
                 const Arc& prev = INVALID) const {
-      if (inNode(u) && outNode(v)) {
-        if (static_cast<const DigraphNode&>(u) ==
-            static_cast<const DigraphNode&>(v) && prev == INVALID) {
-          return Arc(u);
+      if (inNode(u)) {
+        if (outNode(v)) {
+          if (static_cast<const DigraphNode&>(u) ==
+              static_cast<const DigraphNode&>(v) && prev == INVALID) {
+            return Arc(u);
+          }
         }
-      }
-      else if (outNode(u) && inNode(v)) {
-        return Arc(::lemon::findArc(*_digraph, u, v, prev));
+      } else {
+        if (inNode(v)) {
+          return Arc(::lemon::findArc(*_digraph, u, v, prev));
+        }
       }
       return INVALID;
@@ -3156,9 +2922,4 @@
       typedef Node Key;
       typedef _Value Value;
-      typedef typename MapTraits<NodeImpl>::ReferenceMapTag ReferenceMapTag;
-      typedef typename MapTraits<NodeImpl>::ReturnValue ReturnValue;
-      typedef typename MapTraits<NodeImpl>::ConstReturnValue ConstReturnValue;
-      typedef typename MapTraits<NodeImpl>::ReturnValue Reference;
-      typedef typename MapTraits<NodeImpl>::ConstReturnValue ConstReference;
 
       NodeMapBase(const Adaptor& adaptor)
@@ -3173,10 +2934,12 @@
       }
 
-      ReturnValue operator[](const Node& key) {
+      typename MapTraits<NodeImpl>::ReturnValue
+      operator[](const Node& key) {
         if (Adaptor::inNode(key)) { return _in_map[key]; }
         else { return _out_map[key]; }
       }
 
-      ConstReturnValue operator[](const Node& key) const {
+      typename MapTraits<NodeImpl>::ConstReturnValue
+      operator[](const Node& key) const {
         if (Adaptor::inNode(key)) { return _in_map[key]; }
         else { return _out_map[key]; }
@@ -3195,9 +2958,4 @@
       typedef Arc Key;
       typedef _Value Value;
-      typedef typename MapTraits<ArcImpl>::ReferenceMapTag ReferenceMapTag;
-      typedef typename MapTraits<ArcImpl>::ReturnValue ReturnValue;
-      typedef typename MapTraits<ArcImpl>::ConstReturnValue ConstReturnValue;
-      typedef typename MapTraits<ArcImpl>::ReturnValue Reference;
-      typedef typename MapTraits<ArcImpl>::ConstReturnValue ConstReference;
 
       ArcMapBase(const Adaptor& adaptor)
@@ -3215,5 +2973,6 @@
       }
 
-      ReturnValue operator[](const Arc& key) {
+      typename MapTraits<ArcImpl>::ReturnValue
+      operator[](const Arc& key) {
         if (Adaptor::origArc(key)) {
           return _arc_map[key._item.first()];
@@ -3223,5 +2982,6 @@
       }
 
-      ConstReturnValue operator[](const Arc& key) const {
+      typename MapTraits<ArcImpl>::ConstReturnValue
+      operator[](const Arc& key) const {
         if (Adaptor::origArc(key)) {
           return _arc_map[key._item.first()];
@@ -3304,39 +3064,29 @@
   /// \ingroup graph_adaptors
   ///
-  /// \brief Adaptor class for splitting the nodes of a digraph.
-  ///
-  /// SplitNodes adaptor can be used for splitting each node into an
-  /// \e in-node and an \e out-node in a digraph. Formaly, the adaptor
-  /// replaces each node \f$ u \f$ in the digraph with two nodes,
-  /// namely node \f$ u_{in} \f$ and node \f$ u_{out} \f$.
-  /// If there is a \f$ (v, u) \f$ arc in the original digraph, then the
-  /// new target of the arc will be \f$ u_{in} \f$ and similarly the
-  /// source of each original \f$ (u, v) \f$ arc will be \f$ u_{out} \f$.
-  /// The adaptor adds an additional \e bind \e arc from \f$ u_{in} \f$
-  /// to \f$ u_{out} \f$ for each node \f$ u \f$ of the original digraph.
-  ///
-  /// The aim of this class is running an algorithm with respect to node
-  /// costs or capacities if the algorithm considers only arc costs or
-  /// capacities directly.
-  /// In this case you can use \c SplitNodes adaptor, and set the node
-  /// costs/capacities of the original digraph to the \e bind \e arcs
-  /// in the adaptor.
-  ///
-  /// \tparam GR The type of the adapted digraph.
-  /// It must conform to the \ref concepts::Digraph "Digraph" concept.
-  /// It is implicitly \c const.
-  ///
-  /// \note The \c Node type of this adaptor is converible to the \c Node
-  /// type of the adapted digraph.
-  template <typename GR>
-#ifdef DOXYGEN
-  class SplitNodes {
-#else
+  /// \brief Split the nodes of a directed graph
+  ///
+  /// The SplitNodes adaptor splits each node into an in-node and an
+  /// out-node. Formaly, the adaptor replaces each \f$ u \f$ node in
+  /// the digraph with two nodes(namely node \f$ u_{in} \f$ and node
+  /// \f$ u_{out} \f$). If there is a \f$ (v, u) \f$ arc in the
+  /// original digraph the new target of the arc will be \f$ u_{in} \f$
+  /// and similarly the source of the original \f$ (u, v) \f$ arc
+  /// will be \f$ u_{out} \f$.  The adaptor will add for each node in
+  /// the original digraph an additional arc which connects
+  /// \f$ (u_{in}, u_{out}) \f$.
+  ///
+  /// The aim of this class is to run algorithm with node costs if the
+  /// algorithm can use directly just arc costs. In this case we should use
+  /// a \c SplitNodes and set the node cost of the graph to the
+  /// bind arc in the adapted graph.
+  ///
+  /// \tparam _Digraph It must be conform to the \ref concepts::Digraph
+  /// "Digraph concept". The type can be specified to be const.
+  template <typename _Digraph>
   class SplitNodes
-    : public DigraphAdaptorExtender<SplitNodesBase<const GR> > {
-#endif
-  public:
-    typedef GR Digraph;
-    typedef DigraphAdaptorExtender<SplitNodesBase<const GR> > Parent;
+    : public DigraphAdaptorExtender<SplitNodesBase<_Digraph> > {
+  public:
+    typedef _Digraph Digraph;
+    typedef DigraphAdaptorExtender<SplitNodesBase<Digraph> > Parent;
 
     typedef typename Digraph::Node DigraphNode;
